import { ContentTypes } from '../../types';
import Meta from './Meta';
export default (function (contentType, notFoundUrl) {
    if (notFoundUrl === void 0) { notFoundUrl = 'page-not-found'; }
    var type = contentType === ContentTypes.Page
        ? 'website'
        : 'article';
    var mixin = {
        components: {
            Sections: function () { return import("../../components/TheRoot.js"); }
        },
        props: {
            wpData: Object
        },
        watch: {
            wpData: {
                immediate: true,
                handler: function (n) {
                    if (n === false) {
                        this.$router.push(notFoundUrl);
                    }
                }
            }
        },
        mixins: [
            Meta(type, 'wpData')
        ]
    };
    return mixin;
});
//# sourceMappingURL=Abstract.js.map